#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Apr 30 14:30:59 2020

@author: valentinabadie
"""

import numpy as np
import pickle
from shapely.geometry import Polygon, Point
from shapely.ops import cascaded_union as union
import random
from tqdm import tqdm

path_slides = '../data/slides/'
path_labels = '../data/labels/'
path_infos = '../data/info_slides/'
    
class DeterministSampler():
    """ A class to handle the generation of several sub-regions of a slide
    
    Attributes :
        levelSlide : obj, the LevelSlide object to which the sampler is attached
        size : 2-tuple, dimensions of each generated region
        stride : 2-tuple, the stride between 2 consecutive regions
        offset : 2-tuple, distance from the top-left of the slide to start picking regions
        borders : bool, includes or not areas which are partly out of the slide
        ROI : int, selects only the region which interset ROI of the specified class. Set to 0 for no selection (all regions are                 taken into account)
        ROIp : float in [0,1], the minimal amount of ROI which has to interset the region for it to be taken into account. Set                   to 0 to take any region intersecting the ROI.
        
    Methods :
        
        Built-in :
            __init__ : initialises the class
            __getitem__ : gets the regions corresponding to the index passed as input
            __len__ : returns the number of regions to be generated by the sampler
            __repr__ : displays information about the sampler
        
        Backend :
            _set_list_coordinates : makes the list of coordinates of the recangular regions to be retrivied by the sampler
    
    """
    
    def __init__(self, levelSlide, size, stride, offset, borders, ROI, ROIp):
        
        """initialises the class
        
        Inputs :
            levelSlide : obj, the LevelSlide object to which the sampler is attached
            size : 2-tuple, dimensions of each generated region
            stride : 2-tuple, the stride between 2 consecutive regions
            offset : 2-tuple, distance from the top-left of the slide to start picking regions
            borders : bool, includes or not areas which are partly out of the slide
            ROI : int, selects only the region which interset ROI of the specified class. Set to 0 for no selection (all regions are                 taken into account)
            ROIp : float in [0,1], the minimal amount of ROI which has to interset the region for it to be taken into account. Set                   to 0 to take any region intersecting the ROI.
        
        """
        
        self.levelSlide = levelSlide
        
        if type(size) is int :
            self.size = (size, size)
        else :
            self.size = size
            
        if type(stride) is int :
            self.stride = (stride, stride)
        else :
            self.stride = stride
            
        if type(offset) is int :
            self.offset = (offset, offset)
        else :
            self.offset = offset
            
        self.borders = borders
        
        self.ROI = ROI
        
        self.ROIp = ROIp
        
        self._set_list_coordinates()
        
    def _set_list_coordinates(self):
        """Creates a list containing all the positions to be used to compute the iterated regions"""

        #creates a grid of region positions
        positions = [[i for i in range(self.offset[k], self.levelSlide.dims[k], self.stride[k])] for k in [0,1]]
        positions_1 = [[i for i in range(self.offset[k] + self.size[k], self.levelSlide.dims[k] + self.size[k] * int(self.borders), self.stride[k])] for k in [0,1]]
        
        positions_x,positions_x_1 = tuple(zip(*list(zip(positions[0],positions_1[0]))))
        positions_y,positions_y_1 = tuple(zip(*list(zip(positions[1],positions_1[1]))))
        
        positions_x,positions_y = np.meshgrid(positions_x,positions_y)
        positions_x_1,positions_y_1 = np.meshgrid(positions_x_1,positions_y_1)
        
        list_coordinates = list(zip(list(positions_x.flatten()),list(positions_y.flatten()),list(positions_x_1.flatten()),list(positions_y_1.flatten())))
        
        #checks whether the regions are instersecting the chosen ROI (if required)
        if self.ROI != 0 :
            self.list_coordinates = []
            
            for index,coordinates in enumerate(list_coordinates):

                coordinates_x = self.levelSlide.pixel_to_meter(*coordinates)
                coordinates_x = sorted([coordinates_x[0],coordinates_x[2]])+sorted([coordinates_x[1],coordinates_x[3]])
                x1,y1,x2,y2 = coordinates_x[0],coordinates_x[2], coordinates_x[1],coordinates_x[3]

                polygon_region = Polygon([(x1,y1),(x2,y1),(x2,y2),(x1,y2)])
                
                 #check, for every labelled object as the selected ROI, if it intersects the region
                for object_type,coords in list(filter(lambda x:x[0] == self.ROI,self.levelSlide.labels)):              
                
                    #creates a polygon object
                    polygon_label = Polygon([(point[0],point[1]) for point in coords])

                    #checking intersection
                    if polygon_label.intersects(polygon_region):
                        if (polygon_label.intersection(polygon_region)).length >= (polygon_region.length*self.ROIp):
                            self.list_coordinates.append(coordinates)
                            break
        else :
            self.list_coordinates = list_coordinates
                    
    def __getitem__(self,index):
        
        """Gets the region with inptu index
        
        Inputs :
            
            index : the position of the region as defined by the sampler
        """
          
        return self.list_coordinates[index]
    
    def __len__(self):
        """returns the number of regions to be generated by the sampler"""
        return len(self.list_coordinates)
    
    def __repr__(self):
        """Returns the list region coordinates generated by the sampler"""
        return str(self.list_coordinates)
            
class RandomSampler():
    """ A class to handle the generation of several sub-regions of a slide 
    
    Attributes :
    
        levelSlide : obj, the LevelSlide object to which the sampler is attached
        size : 2-tuple, dimensions of each generated region
        ROI : int, selects only the region which interset ROI of the specified class. Set to 0 for no selection (all regions are                 taken into account)
        balance : float, between 0 and 1, the ratio of positive samples in the dataset
        tolerance : int, in case of negative sample generation (i.e. no objects in it), say at which point the negative sample is needed to be negative, i.e. at what distance (in terms of infinite norm) the nearest object has to be away from the center of the sample.
        include_gray_matter : bool. If True, only regions in gray matter will be sampled; Defualt : True.
        data_aug : int. When generating a positive samples from an objects, says how many positive samples to generate from the same object. For more details, see report.
        
        
    Methods :
    
        Built-in :
            __init__ : initialises the class
            __getitem__ : gets a region as defined by the sampler
            __call__ : same as getitem, is used in the case of data_aug >= 2
            __len__ : returns the number of regions to be generated by the sampler
            __repr__ : returns the list region coordinates generated by the sampler
            
        Backend :
            _positive_sampler : sampler for generating positive examples
            _negative_sampler : sampler for generating negative examples
            _set_sampler : associates _positive_sampler and _negative_sampler to make an overall sampler
    """
    
    def __init__(self, levelSlide, size, ROI = 2, balance = 0.5, tolerance = None, include_gray_matter = True, data_aug = 1):
        
        """initialises the class
        
        Inputs :
        
            levelSlide : obj, the LevelSlide object to which the sampler is attached
            size : 2-tuple, dimensions of each generated region
            ROI : int, selects only the region which interset ROI of the specified class. Set to 0 for no selection (all regions are                 taken into account)
            balance : float, between 0 and 1, the ratio of positive samples in the dataset
            tolerance : int, in case of negative sample generation (i.e. no objects in it), say at which point the negative sample is needed to be negative, i.e. at what distance (in terms of infinite norm) the nearest object has to be away from the center of the sample.
            include_gray_matter : bool. If True, only regions in gray matter will be sampled; Defualt : True.
            data_aug : int. When generating a positive samples from an objects, says how many positive samples to generate from the same object. For more details, see report.
        
        """
        
        self.levelSlide = levelSlide
        
        if type(size) is int :
            self.size = (size, size)
        else :
            self.size = size
        
        if tolerance is None :
            self.tolerance = size
        elif type(size) is int :
            self.tolerance = (tolerance, tolerance)
        else :
            self.tolerance = tolerance
            
        self.data_aug = data_aug
        
        self.ROI = ROI
        
        self.balance = balance
        
        self.include_gray_matter = include_gray_matter
        
        self._set_sampler()
        
    def _positive_sampler(self):
        
        """Creates a list containing all the positions of the regions containing positive samples"""
        
        #generate a list of all rois under the Polygon format, easy to process with
        self.list_ROI = [Polygon([(point[0], point[1]) for point in coord]) for _,coord in filter(lambda x: x[0] == self.ROI, self.levelSlide.labels)]
        
        
        #compute the centroids of each roi
        list_roi_positions = [self.levelSlide.meter_to_pixel(*roi.centroid.coords[:][0]) for roi in self.list_ROI]
        
        if self.data_aug <= 0:
            #retrieves the coordinates of all regions corresponding to the negatives samples
            self.list_coordinates_positives = [(x-self.size[0]//2, y-self.size[1]//2, x+self.size[0]//2, y+self.size[1]//2) for x,y in list_roi_positions]
            
        #if data augmentation is needed, performs random oversampling of each ROI
        elif self.data_aug == 1:
            list_roi_bounds = [self.levelSlide.meter_to_pixel(*roi.bounds) for roi in self.list_ROI]
            
            
            #defines a rectangle in which the centroid of the region can be chosen while keeping the whole ROI in it
            random_squares = [(max(x1,x2) - self.size[0]//2, max(y1,y2) - self.size[1]//2, min(x1,x2) + self.size[0]//2, min(y1,y2) + self.size[1]//2) for x1,y1,x2,y2 in list_roi_bounds]
            
            #make data_aug random samples within the square
            list_roi_positions = list()
            for square in random_squares :
                list_roi_x = np.random.randint(square[0], square[2], size = self.data_aug)
                list_roi_y = np.random.randint(square[1], square[3], size = self.data_aug)
                list_roi_positions += list(zip(list_roi_x, list_roi_y))
            
            #retrieves the regions boundaries of the randomly generated samples
            self.list_coordinates_positives = [(x-self.size[0]//2, y-self.size[1]//2, x+self.size[0]//2, y+self.size[1]//2) for x,y in list_roi_positions]
        else :
            list_roi_bounds = [self.levelSlide.meter_to_pixel(*roi.bounds) for roi in self.list_ROI]
            
            #defines a rectangle in which the centroid of the region can be chosen while keeping the whole ROI in it
            random_squares = [(max(x1,x2) - self.size[0]//2, max(y1,y2) - self.size[1]//2, min(x1,x2) + self.size[0]//2, min(y1,y2) + self.size[1]//2) for x1,y1,x2,y2 in list_roi_bounds]
            
            #make data_aug random samples within the square
            list_roi_positions = list()
            for square in random_squares :
                list_roi_x = np.random.randint(square[0], square[2], size = self.data_aug)
                list_roi_y = np.random.randint(square[1], square[3], size = self.data_aug)
                list_roi_positions.append(list(zip(list_roi_x, list_roi_y)))
            
            #retrieves the regions boundaries of the randomly generated samples
            self.list_coordinates_positives = [[(x-self.size[0]//2, y-self.size[1]//2, x+self.size[0]//2, y+self.size[1]//2) for x,y in roi_positions] for roi_positions in list_roi_positions]

    def _negative_sampler(self, num_random_samples = None, nb_iterations = 40):
        
        """Randomly samples negative samples, with flexible definition of negative : it can be rid of any ROI, but the user can choose to have partly ROIs via the parameter tolerance
        The algorithm iteratively randomly selects num_random_samples regions and keeps the one which corresponds to the definition, up to having same num_neg_samples negative samples, or having performed nb_iterations iterations. In the second case, the remaining samples are just given by copying already retrieved ones.
        
        Inputs :
            num_random_samples : int, number of negative sampels to be generated.
            nb_iterations : int, maximum number of iterations before the sampler stop trying to get negative samples.
        """
        
        num_neg_samples = int(len(self.list_coordinates_positives)*(1-self.balance)/self.balance)
        num_neg_samples = num_neg_samples*self.data_aug if self.data_aug >= 1 else num_neg_samples
        
        #creates a union of all rois to be avoided
        union_roi = union(self.list_ROI)
        
        #creates a polygon corresponding to the whole gray matter
        if self.include_gray_matter :
            union_gray_matter = union([Polygon([(point[0], point[1]) for point in coord]) for _,coord in filter(lambda x: x[0] == 1, self.levelSlide.labels)])
        
        #defines the number of random samples to be generated at each iteration
        num_random_samples = num_neg_samples if num_random_samples is None else num_random_samples
        
        self.list_coordinates_negatives = list()
        break_loop = False
        for it in tqdm(range(nb_iterations)):
            
            if break_loop :
                break
            
            #creates num_random_samples random samples of positions on the slide
            bounds = self.levelSlide.pixel_to_meter(self.size[0]//2, self.size[1]//2, self.levelSlide.dims[0] - self.size[0]//2, self.levelSlide.dims[1] - self.size[1]//2)
            bounds = [min(bounds[0],bounds[2]),min(bounds[1],bounds[3]),max(bounds[0],bounds[2]),max(bounds[1],bounds[3])]
            x = (bounds[2] - bounds[0])*np.random.random((num_random_samples,)) + bounds[0]
            y = (bounds[3] - bounds[1])*np.random.random((num_random_samples,)) + bounds[1]
            random_positions = np.vstack((x, y)).T
            
            #only keeps positions in gray matter         
            if self.include_gray_matter :
                random_positions = np.array([[x,y] for x,y in random_positions if Point(x,y).within(union_gray_matter)])

            #computes the coordinates of the corresponding region
            random_positions_pixel = [self.levelSlide.meter_to_pixel(x,y) for x,y in random_positions]
            random_regions = [(x-self.size[0]//2, y-self.size[1]//2, x+self.size[0]//2, y+self.size[1]//2) for x,y in random_positions_pixel]
            
            #computes the coordinates of the tolerance zone
            random_regions_tolerance_zone = [self.levelSlide.pixel_to_meter(*(x-self.tolerance[0]//2, y-self.tolerance[1]//2, x+self.tolerance[0]//2, y+self.tolerance[1]//2)) for x,y in random_positions_pixel]
            
            #appends valid regions to the dataset
            for i, region in enumerate(random_regions):

                #checks if there is no roi in the tolerance zone
                x1,y1,x2,y2 = random_regions_tolerance_zone[i]
                if not Polygon([(x1,y1),(x1,y2),(x2,y2),(x2,y1)]).intersects(union_roi):
                    self.list_coordinates_negatives.append(region)

                #checks if the list of samples has its expected size
                if len(self.list_coordinates_negatives) >= num_neg_samples :
                    break_loop = True
                    break
                
        if len(self.list_coordinates_negatives) < num_neg_samples :
            self.list_coordinates_negatives += self.list_coordinates_negatives[:(num_neg_samples - len(self.list_coordinates_negatives))]
            
        if self.data_aug >= 2 :
            self.list_coordinates_negatives = [[self.list_coordinates_negatives[j] for j in range(i, i+self.data_aug)] for i in range(0,len(self.list_coordinates_negatives), self.data_aug)]
            
    def _set_sampler(self, nb_iterations = 40):
        
        """Associates _positive_sampler and _negative_sampler to make an overall sampler
        
        Inputs :
            nb_iterations : int, maximum number of iterations before the negative sampler stop trying to get negative samples.
        """
        
        self._positive_sampler()
        self._negative_sampler(nb_iterations = nb_iterations)
        self.list_coordinates = self.list_coordinates_positives + self.list_coordinates_negatives
        random.shuffle(self.list_coordinates)

    def __call__(self,*index):
        """basic function of a list"""
        if self.data_aug >= 2 :
            print(index)
            return self.list_coordinates[index[0]][index[1]]
        else : 
            return self.list_coordinates[index[0]]
        
    def __getitem__(self, index):
        
        """Gets the region with inptu index
        
        Inputs :
            
            index : the position of the region as defined by the sampler
        """
        
        return self.list_coordinates[index]
    
    def __len__(self):
        """returns the number of regions to be generated by the sampler"""
        return len(self.list_coordinates)
    
    def __repr__(self):
        """returns the list region coordinates generated by the sampler"""
        return str(self.list_coordinates)
            